﻿package worldscape
{
	import flash.display.Bitmap;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	/**
	 * ...
	 * @author DefaultUser (Tools -> Custom Arguments...)
	 */
	public class Main extends Sprite 
	{
		[Embed(source = '../../lib/Contrast_by_MaNi3k.png')]
		private var backgroundClass:Class;
		private var background:Bitmap = new backgroundClass();
		private var myMask:Sprite;
		private var myMaskSize:Number = 100;
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);

			// add a background image
			addChild(background);
			
			// draw the mask
			myMask = new Sprite();
			myMask.graphics.beginFill(0x00FF00);
			myMask.graphics.drawRect(0, 0, myMaskSize, myMaskSize);
			// move it to the center of the screen
			myMask.x = 350;
			myMask.y = 250;
			addChild(myMask);
			
			// apply the mask
			background.mask = myMask;
			
			// add listeners for the left mouse button and mouse wheel
			stage.addEventListener(MouseEvent.MOUSE_DOWN, mouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, mouseReleased);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, mouseWheel);
		}

		private function mouseDown(event:MouseEvent):void {
			myMask.startDrag();
		}

		private function mouseReleased(event:MouseEvent):void {
			myMask.stopDrag();
		}
		
		private function mouseWheel(event:MouseEvent):void {
			myMaskSize += event.delta*5;
			myMask.graphics.clear();
			myMask.graphics.beginFill(0x00FF00);
			myMask.graphics.drawRect(0, 0, myMaskSize, myMaskSize);
		}
	}
	
}